Subject: bug#42147: 28.0.50; pure vs side-effect-free, missing optimizations?

From: Andrea Corallo <[email-masked]>
Date: Thu, 2 Jul 2020 18:55:23 +0000 (UTC)

Mattias Engdegård <[email-masked]> writes:

> 2 juli 2020 kl. 17.49 skrev Stefan Monnier <[email-masked]>:
>
>> Better yet, there's still hope that we change things such that `eq`
>> behaves like `eql` on bignums (and maybe also on floats).
>
> Speaking of which, Andrea may be in a good position to provide us with
> performance data about such a change, since making 'eq' more expensive
> is likely to be more visible in native code (assuming the operation is
> open-coded) than in bytecode or interpreted lisp. On the other hand,
> perhaps his compiler thingamajig is able to eliminate some checks
> statically by type propagation?

Correct, in case we would certainly opencode it and use the thingamajig
trying to eliminate the type checks we can.